;-------------------------------------
!pose = !1504
!state = !1510
!move_count = !151C
!timer = !1540
!anime_count = !1602
!muteki = !1558

move_table:
	db $78,$30,$78,$C0
speed_table:
	db $E8,$E8,$18,$18
anime_table:
	db $00,$01,$00
	db $01,$00,$01
;-------------------------------------
Tiles:
	db $80,$82,$A0,$A2 ;移動1
	db $84,$86,$A4,$A6 ;移動2
	db $89,$8B,$A9,$AB,$98 ;ショット
	db $8D,$8E,$9D,$9E ;ダメージエフェクト

XOffset:
	db $F8,$08,$F8,$08 ;移動1
	db $F8,$08,$F8,$08 ;移動2
	db $F8,$08,$F8,$08,$F0 ;ショット
	db $FC,$04,$FC,$04 ;ダメージエフェクト

YOffset:
	db $F0,$F0,$00,$00 ;移動1
	db $F0,$F0,$00,$00 ;移動2
	db $F0,$F0,$00,$00,$F8 ;ショット
	db $F8,$F8,$00,$00 ;ダメージエフェクト
;-------------------------------------

print "INIT ",pc
	RTL

print "MAIN ",pc
	PHB
	PHK
	PLB
	JSR sprite
	PLB
	RTL
	
sprite:
	JSR gfx
	LDA #$00
	%SubOffScreen()
	
	LDA $9D
	BNE return
	LDA !sprite_status,x
	CMP #$08
	BNE return

	LDA !state,x
	JSL $0086DF|!BankB
	dw wait,posing,hpup,move1,shot1,move2

wait:
	%SubHorzPos()
	TYA
	STA !157C,x
	LDA !sprite_y_high,x
	CMP $97
	BNE +
	LDA $77
	AND #$04
	BEQ +
	LDA #$0B
	STA $71
	JSL $01802A|!BankB
	LDA !sprite_blocked_status,x
	AND #$04
	BEQ +
	STZ !pose,x
	INC !state,x
	LDA #$08
	STA !timer,x
+
return:
	RTS

posing:
	LDA !timer,x
	BNE +
	LDA !pose,x
	CMP #$02
	BCS ++
	INC !pose,x
	LDA #$08
	STA !timer,x
+
	RTS
++
	STZ $00
	LDA #$C0
	STA $01
	STZ $02
	STZ $03
	DEC A
	SEC
	INC !state,x
	LDA #$10
	STA !timer,x
	RTS

hpup:
	LDA !timer,x
	BNE +
	LDA !C2,x
	CMP #$30
	BCS ++
	INC A
	STA !C2,x
	LDA #$01
	STA $1DFC|!Base2
	LDA #$02
	STA !timer,x
+
	RTS
++
	INC !state,x
	LDA #$10
	STA !timer,x
	STZ $71
	RTS

move1:
	JSR check_mario
	LDA !timer,x
	BNE +
	JSR sprite_moving
	LDA !move_count,x

shot1:

move2:

Return:
RTS

sprite_moving:
	JSL $01802A|!BankB
	LDA !sprite_blocked_status,x
	AND #$08
	BEQ +
	STZ !sprite_speed_y,x
+
	LDA !sprite_blocked_status,x
	AND #$04
	BEQ ++
	STZ !sprite_speed_y,x
	LDA !anime_count,x
	INC A
	STA !anime_count,x
	CMP #$30
	BCC +
	STZ !anime_count,x
+
	LDA !anime_count,x
	LSR #3
	AND #$07
	TAY
	LDA anime_table,y
	STA !pose,x
	BRA +++
++
	LDA #$03
	STA !pose,x
+++
	LDA !sprite_blocked_status,x
	AND #$03
	BEQ +
	LDA #$E0
	STA !sprite_speed_y,x
+
	RTS
check_mario:
	LDA !muteki,x
	BNE not_contact
	JSL $01A7DC|!BankB
	BCC not_contact
	%SubVertPos()
	LDA $0F
	CMP #$F0
	BPL boss_win
	LDA $7D
	BPL mario_win
boss_win:
	JSL $00F5B7|!BankB
	RTS
mario_win:
	LDA #$20
	STA !muteki,x
	JSL $01AA33|!BankB
	JSL $01AB99|!BankB
	DEC !C2,x
	LDA !C2,x
	BNE +
	LDA #$02
	STA !sprite_status,x
	STZ !sprite_speed_x,x
	STZ !sprite_speed_y,x
+
not_contact:
	RTS

gfx:
	%GetDrawInfo()
	
	LDA !157C,x
	EOR #$01
	ASL #6
	STA $02
	
LDA !muteki,x
    BEQ +
    LDA $14
    AND #$01
    BEQ +
    LDA #$08
    BRA ++
+
    LDA !pose,x
++
    ASL #2
    STA $03
    
    LDA !15F6,x
    STA $04
    
    PHX
    LDX #$03
-
    PHX
    TXA
    ORA $03
    TAX
	
	LDA XOffset,x
	PHX
	LDX $02
	BEQ +
	EOR #$FF
	INC A
+
	PLX
	CLC
	ADC $00
	STA $0300|!Base2,y
	LDA Tiles,x
	STA $0302|!Base2,y
	PLX
	
	LDA YOffset,x
	CLC
	ADC $01
	STA $0301|!Base2,y
	
	LDA $04
	ORA $02
	ORA $64
	STA $0303|!Base2,y
	
	INY #4
	DEX
	BPL -
	
	PLX
	LDY #$02
	LDA #$03
	%FinishOAMWrite()
	RTS
